# Blocks

Blocks are the building blocks of blockchains and rollups. A block contains transactions that will alter the state of an EVM system incrementally. Transactions within a block can only be executed one after the other, not in parallel.

These tables are useful for identifying block activity and transaction changes over time.

## ETL data class

| Column Name                   | Data Type | Note        |
| ----------------------------- | --------- | ----------- |
| timestamp                     | timestamp |             |
| number                        | int       |             |
| hash                          | str       | primary key |
| parent\_hash                  | str       |             |
| nonce                         | str       |             |
| sha3\_uncles                  | str       |             |
| transactions\_root            | str       |             |
| state\_root                   | str       |             |
| receipts\_root                | str       |             |
| miner                         | str       |             |
| difficulty                    | int       |             |
| total\_difficulty             | int       |             |
| size                          | int       |             |
| extra\_data                   | str       |             |
| gas\_limit                    | int       |             |
| gas\_used                     | int       |             |
| transactions\_count           | int       |             |
| base\_fee\_per\_gas           | int       |             |
| withdrawals\_root             | str       |             |
| blob\_gas\_used               | int       |             |
| excess\_blob\_gas             | int       |             |
| traces\_count                 | int       |             |
| internal\_transactions\_count | int       |             |

Examples

```json
{
  "timestamp": "2023-10-29T03:34:19.000Z",
  "number": 435530,
  "hash": "0x68189ad6461faff3837f22571813eb507de3bdca2d1c9b596f233bd1fc8ff810",
  "parent_hash": "0x04db8bfd20912bba895e7697f48997c38ebe95a7392e58f7b88777764555a50c",
  "nonce": "0",
  "sha3_uncles": "0x1dcc4de8dec75d7aab85b567b6ccd41ad312451b948a7413f0a142fd40d49347",
  "transactions_root": "0x5c704be9d382467cb8ee1e12f0ab04e30592d3fb9acb8fe7fda7e2a09bc788b0",
  "state_root": "0xeb14acf5feb30868d3ed1a29d4e1347beca86b5086a8e516041e7d237e7c0f7a",
  "receipts_root": "0x40c0b3b1cb04517954a19c2d24b5a30042fc1d0281e3b9a8ffffae13a0aa9269",
  "miner": "0x4200000000000000000000000000000000000011",
  "difficulty": 0,
  "total_difficulty": 0,
  "size": 3047,
  "extra_data": "0x",
  "gas_limit": 30000000,
  "gas_used": 965239,
  "transactions_count": 7,
  "base_fee_per_gas": 50
}
```

| Column Name                   | Data Type    | Note          |
| ----------------------------- | ------------ | ------------- |
| hash                          | bytea        | primary key   |
| number                        | bigint       |               |
| timestamp                     | timestamp    |               |
| parent\_hash                  | bytea        |               |
| nonce                         | bytea        |               |
| gas\_limit                    | numeric(100) |               |
| gas\_used                     | numeric(100) |               |
| base\_fee\_per\_gas           | numeric(100) |               |
| difficulty                    | numeric(38)  |               |
| total\_difficulty             | numeric(38)  |               |
| size                          | bigint       |               |
| miner                         | bytea        |               |
| sha3\_uncles                  | bytea        |               |
| transactions\_root            | bytea        |               |
| transactions\_count           | bigint       |               |
| state\_root                   | bytea        |               |
| receipts\_root                | bytea        |               |
| extra\_data                   | bytea        |               |
| withdrawals\_root             | bytea        |               |
| create\_time                  | timestamp    | default now() |
| update\_time                  | timestamp    | default now() |
| reorg                         | boolean      |               |
| blob\_gas\_used               | numeric(100) |               |
| excess\_blob\_gas             | numeric(100) |               |
| traces\_count                 | bigint       |               |
| internal\_transactions\_count | bigint       |               |

Examples

```json
{
  "hash": "E'\\\\x68189AD6461FAFF3837F22571813EB507DE3BDCA2D1C9B596F233BD1FC8FF810'",
  "number": 435530,
  "timestamp": "2023-10-29 03:34:19.000000",
  "parent_hash": "E'\\\\x04DB8BFD20912BBA895E7697F48997C38EBE95A7392E58F7B88777764555A50C'",
  "nonce": "E'\\\\x0000000000000000'",
  "gas_limit": 30000000,
  "gas_used": 965239,
  "base_fee_per_gas": 50,
  "difficulty": 0,
  "total_difficulty": 0,
  "size": 3047,
  "miner": "E'\\\\x4200000000000000000000000000000000000011'",
  "sha3_uncles": "E'\\\\x1DCC4DE8DEC75D7AAB85B567B6CCD41AD312451B948A7413F0A142FD40D49347'",
  "transactions_root": "E'\\\\x5C704BE9D382467CB8EE1E12F0AB04E30592D3FB9ACB8FE7FDA7E2A09BC788B0'",
  "transactions_count": 7,
  "state_root": "E'\\\\xEB14ACF5FEB30868D3ED1A29D4E1347BECA86B5086A8E516041E7D237E7C0F7A'",
  "receipts_root": "E'\\\\x40C0B3B1CB04517954A19C2D24B5A30042FC1D0281E3B9A8FFFFAE13A0AA9269'",
  "extra_data": "E'\\\\x'",
  "withdrawals_root": null,
  "create_time": "2024-08-12 13:38:46.949956",
  "update_time": null,
  "reorg": false,
  "blob_gas_used": null,
  "excess_blob_gas": null,
  "traces_count": 15,
  "internal_transactions_count": 3
}
```

```csv
0x68189AD6461FAFF3837F22571813EB507DE3BDCA2D1C9B596F233BD1FC8FF810,435530,2023-10-29 03:34:19.000000,0x04DB8BFD20912BBA895E7697F48997C38EBE95A7392E58F7B88777764555A50C,0x0000000000000000,30000000,965239,50,0,0,3047,0x4200000000000000000000000000000000000011,0x1DCC4DE8DEC75D7AAB85B567B6CCD41AD312451B948A7413F0A142FD40D49347,0x5C704BE9D382467CB8EE1E12F0AB04E30592D3FB9ACB8FE7FDA7E2A09BC788B0,7,0xEB14ACF5FEB30868D3ED1A29D4E1347BECA86B5086A8E516041E7D237E7C0F7A,0x40C0B3B1CB04517954A19C2D24B5A30042FC1D0281E3B9A8FFFFAE13A0AA9269,0x,null,2024-08-12 13:38:46.949956,null,false,null,null,15,3
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.thehemera.com/hemera-indexer/data-class/raw-data-tables/blocks.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
